import '_model.dart';

class CrmIntouchHistory {
  int? id;
  String? leadUuid;
  int? intouchTrackCreatedBy;
  int? intouchTrackCreatedAt;
  String? comment;
  CrmStatus? status;
  CrmIntouch? intouch;

  CrmIntouchHistory(
      {this.id,
      this.leadUuid,
      this.intouchTrackCreatedBy,
      this.intouchTrackCreatedAt,
      this.comment,
      this.status,
      this.intouch});

  CrmIntouchHistory.fromJson(Map<String, dynamic> json) {
    id = json["id"];
    leadUuid = json["leadUuid"];
    intouchTrackCreatedBy = json["intouchTrackCreatedBy"];
    intouchTrackCreatedAt = json["intouchTrackCreatedAt"];
    comment = json["comment"];
    status = json["status"] == null ? null : CrmStatus.fromJson(json["status"]);
    intouch =
        json["intouch"] == null ? null : CrmIntouch.fromJson(json["intouch"]);
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> _data = <String, dynamic>{};
    _data["id"] = id;
    _data["leadUuid"] = leadUuid;
    _data["intouchTrackCreatedBy"] = intouchTrackCreatedBy;
    _data["intouchTrackCreatedAt"] = intouchTrackCreatedAt;
    _data["comment"] = comment;
    if (status != null) {
      _data["status"] = status?.toJson();
    }
    if (intouch != null) {
      _data["intouch"] = intouch?.toJson();
    }
    return _data;
  }

  CrmIntouchHistory copyWith({
    int? id,
    String? leadUuid,
    int? intouchTrackCreatedBy,
    int? intouchTrackCreatedAt,
    String? comment,
    CrmStatus? status,
    CrmIntouch? intouch,
  }) =>
      CrmIntouchHistory(
        id: id ?? this.id,
        leadUuid: leadUuid ?? this.leadUuid,
        intouchTrackCreatedBy:
            intouchTrackCreatedBy ?? this.intouchTrackCreatedBy,
        intouchTrackCreatedAt:
            intouchTrackCreatedAt ?? this.intouchTrackCreatedAt,
        comment: comment ?? this.comment,
        status: status ?? this.status,
        intouch: intouch ?? this.intouch,
      );
}
