class SeachPlaceResultDetailModel {
  List<AddressComponents>? addressComponents;
  String? adrAddress;
  String? businessStatus;
  String? formattedAddress;
  String? formattedPhoneNumber;
  DetailGeometry? geometry;
  String? icon;
  String? iconBackgroundColor;
  String? iconMaskBaseUri;
  String? internationalPhoneNumber;
  String? name;
  DetailOpeningHours? openingHours;
  List<DetailPhotos>? photos;
  String? placeId;
  PlusCodeModel? plusCode;
  int? priceLevel;
  double? rating;
  String? reference;
  List<Reviews>? reviews;
  List<String>? types;
  String? url;
  int? userRatingsTotal;
  int? utcOffset;
  String? vicinity;
  String? website;

  SeachPlaceResultDetailModel(
      {this.addressComponents,
      this.adrAddress,
      this.businessStatus,
      this.formattedAddress,
      this.formattedPhoneNumber,
      this.geometry,
      this.icon,
      this.iconBackgroundColor,
      this.iconMaskBaseUri,
      this.internationalPhoneNumber,
      this.name,
      this.openingHours,
      this.photos,
      this.placeId,
      this.plusCode,
      this.priceLevel,
      this.rating,
      this.reference,
      this.reviews,
      this.types,
      this.url,
      this.userRatingsTotal,
      this.utcOffset,
      this.vicinity,
      this.website});

  String get street =>
      (addressComponents?.any((e) => e.types?.contains('street_number') ?? false) ?? false
          ? (addressComponents
                  ?.firstWhere((e) => e.types?.contains('street_number') ?? false)
                  .longName ??
              '')
          : '') +
      " " +
      (addressComponents?.any((e) => e.types?.contains('route') ?? false) ?? false
          ? (addressComponents?.firstWhere((e) => e.types?.contains('route') ?? false).longName ??
              '')
          : '');
  String get city =>
      addressComponents?.any((e) => e.types?.contains('administrative_area_level_2') ?? false) ??
              false
          ? (addressComponents
                  ?.firstWhere((e) => e.types?.contains('administrative_area_level_2') ?? false)
                  .longName ??
              '')
          : '';
  String get state =>
      addressComponents?.any((e) => e.types?.contains('administrative_area_level_1') ?? false) ??
              false
          ? (addressComponents
                  ?.firstWhere((e) => e.types?.contains('administrative_area_level_1') ?? false)
                  .longName ??
              '')
          : '';

  String get postalCode =>
      addressComponents?.any((e) => e.types?.contains('postal_code') ?? false) ?? false
          ? (addressComponents
                  ?.firstWhere((e) => e.types?.contains('postal_code') ?? false)
                  .longName ??
              '')
          : '';
  String get country => addressComponents?.any((e) => e.types?.contains('country') ?? false) ??
          false
      ? (addressComponents?.firstWhere((e) => e.types?.contains('country') ?? false).longName ?? '')
      : '';

  SeachPlaceResultDetailModel.fromJson(Map<String, dynamic> json) {
    if (json["address_components"] is List)
      this.addressComponents = json["address_components"] == null
          ? null
          : (json["address_components"] as List).map((e) => AddressComponents.fromJson(e)).toList();
    if (json["adr_address"] is String) this.adrAddress = json["adr_address"];
    if (json["business_status"] is String) this.businessStatus = json["business_status"];
    if (json["formatted_address"] is String) this.formattedAddress = json["formatted_address"];
    if (json["formatted_phone_number"] is String)
      this.formattedPhoneNumber = json["formatted_phone_number"];
    if (json["geometry"] is Map)
      this.geometry = json["geometry"] == null ? null : DetailGeometry.fromJson(json["geometry"]);
    if (json["icon"] is String) this.icon = json["icon"];
    if (json["icon_background_color"] is String)
      this.iconBackgroundColor = json["icon_background_color"];
    if (json["icon_mask_base_uri"] is String) this.iconMaskBaseUri = json["icon_mask_base_uri"];
    if (json["international_phone_number"] is String)
      this.internationalPhoneNumber = json["international_phone_number"];
    if (json["name"] is String) this.name = json["name"];
    if (json["opening_hours"] is Map)
      this.openingHours =
          json["opening_hours"] == null ? null : DetailOpeningHours.fromJson(json["opening_hours"]);
    if (json["photos"] is List)
      this.photos = json["photos"] == null
          ? null
          : (json["photos"] as List).map((e) => DetailPhotos.fromJson(e)).toList();
    if (json["place_id"] is String) this.placeId = json["place_id"];
    if (json["plus_code"] is Map)
      this.plusCode = json["plus_code"] == null ? null : PlusCodeModel.fromJson(json["plus_code"]);
    if (json["price_level"] is int) this.priceLevel = json["price_level"];
    if (json["rating"] is double) this.rating = json["rating"];
    if (json["reference"] is String) this.reference = json["reference"];
    if (json["reviews"] is List)
      this.reviews = json["reviews"] == null
          ? null
          : (json["reviews"] as List).map((e) => Reviews.fromJson(e)).toList();
    if (json["types"] is List)
      this.types = json["types"] == null ? null : List<String>.from(json["types"]);
    if (json["url"] is String) this.url = json["url"];
    if (json["user_ratings_total"] is int) this.userRatingsTotal = json["user_ratings_total"];
    if (json["utc_offset"] is int) this.utcOffset = json["utc_offset"];
    if (json["vicinity"] is String) this.vicinity = json["vicinity"];
    if (json["website"] is String) this.website = json["website"];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    if (this.addressComponents != null)
      data["address_components"] = this.addressComponents?.map((e) => e.toJson()).toList();
    data["adr_address"] = this.adrAddress;
    data["business_status"] = this.businessStatus;
    data["formatted_address"] = this.formattedAddress;
    data["formatted_phone_number"] = this.formattedPhoneNumber;
    if (this.geometry != null) data["geometry"] = this.geometry?.toJson();
    data["icon"] = this.icon;
    data["icon_background_color"] = this.iconBackgroundColor;
    data["icon_mask_base_uri"] = this.iconMaskBaseUri;
    data["international_phone_number"] = this.internationalPhoneNumber;
    data["name"] = this.name;
    if (this.openingHours != null) data["opening_hours"] = this.openingHours?.toJson();
    if (this.photos != null) data["photos"] = this.photos?.map((e) => e.toJson()).toList();
    data["place_id"] = this.placeId;
    if (this.plusCode != null) data["plus_code"] = this.plusCode?.toJson();
    data["price_level"] = this.priceLevel;
    data["rating"] = this.rating;
    data["reference"] = this.reference;
    if (this.reviews != null) data["reviews"] = this.reviews?.map((e) => e.toJson()).toList();
    if (this.types != null) data["types"] = this.types;
    data["url"] = this.url;
    data["user_ratings_total"] = this.userRatingsTotal;
    data["utc_offset"] = this.utcOffset;
    data["vicinity"] = this.vicinity;
    data["website"] = this.website;
    return data;
  }
}

class Reviews {
  String? authorName;
  String? authorUrl;
  String? language;
  String? profilePhotoUrl;
  int? rating;
  String? relativeTimeDescription;
  String? text;
  int? time;

  Reviews(
      {this.authorName,
      this.authorUrl,
      this.language,
      this.profilePhotoUrl,
      this.rating,
      this.relativeTimeDescription,
      this.text,
      this.time});

  Reviews.fromJson(Map<String, dynamic> json) {
    if (json["author_name"] is String) this.authorName = json["author_name"];
    if (json["author_url"] is String) this.authorUrl = json["author_url"];
    if (json["language"] is String) this.language = json["language"];
    if (json["profile_photo_url"] is String) this.profilePhotoUrl = json["profile_photo_url"];
    if (json["rating"] is int) this.rating = json["rating"];
    if (json["relative_time_description"] is String)
      this.relativeTimeDescription = json["relative_time_description"];
    if (json["text"] is String) this.text = json["text"];
    if (json["time"] is int) this.time = json["time"];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data["author_name"] = this.authorName;
    data["author_url"] = this.authorUrl;
    data["language"] = this.language;
    data["profile_photo_url"] = this.profilePhotoUrl;
    data["rating"] = this.rating;
    data["relative_time_description"] = this.relativeTimeDescription;
    data["text"] = this.text;
    data["time"] = this.time;
    return data;
  }
}

class PlusCodeModel {
  String? compoundCode;
  String? globalCode;

  PlusCodeModel({this.compoundCode, this.globalCode});

  PlusCodeModel.fromJson(Map<String, dynamic> json) {
    if (json["compound_code"] is String) this.compoundCode = json["compound_code"];
    if (json["global_code"] is String) this.globalCode = json["global_code"];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data["compound_code"] = this.compoundCode;
    data["global_code"] = this.globalCode;
    return data;
  }
}

class DetailPhotos {
  int? height;
  List<String>? htmlAttributions;
  String? photoReference;
  int? width;

  DetailPhotos({this.height, this.htmlAttributions, this.photoReference, this.width});

  DetailPhotos.fromJson(Map<String, dynamic> json) {
    if (json["height"] is int) this.height = json["height"];
    if (json["html_attributions"] is List)
      this.htmlAttributions =
          json["html_attributions"] == null ? null : List<String>.from(json["html_attributions"]);
    if (json["photo_reference"] is String) this.photoReference = json["photo_reference"];
    if (json["width"] is int) this.width = json["width"];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data["height"] = this.height;
    if (this.htmlAttributions != null) data["html_attributions"] = this.htmlAttributions;
    data["photo_reference"] = this.photoReference;
    data["width"] = this.width;
    return data;
  }
}

class DetailOpeningHours {
  bool? openNow;
  List<Periods>? periods;
  List<String>? weekdayText;

  DetailOpeningHours({this.openNow, this.periods, this.weekdayText});

  DetailOpeningHours.fromJson(Map<String, dynamic> json) {
    if (json["open_now"] is bool) this.openNow = json["open_now"];
    if (json["periods"] is List)
      this.periods = json["periods"] == null
          ? null
          : (json["periods"] as List).map((e) => Periods.fromJson(e)).toList();
    if (json["weekday_text"] is List)
      this.weekdayText =
          json["weekday_text"] == null ? null : List<String>.from(json["weekday_text"]);
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data["open_now"] = this.openNow;
    if (this.periods != null) data["periods"] = this.periods?.map((e) => e.toJson()).toList();
    if (this.weekdayText != null) data["weekday_text"] = this.weekdayText;
    return data;
  }
}

class Periods {
  Close? close;
  Open? open;

  Periods({this.close, this.open});

  Periods.fromJson(Map<String, dynamic> json) {
    if (json["close"] is Map)
      this.close = json["close"] == null ? null : Close.fromJson(json["close"]);
    if (json["open"] is Map) this.open = json["open"] == null ? null : Open.fromJson(json["open"]);
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    if (this.close != null) data["close"] = this.close?.toJson();
    if (this.open != null) data["open"] = this.open?.toJson();
    return data;
  }
}

class Open {
  int? day;
  String? time;

  Open({this.day, this.time});

  Open.fromJson(Map<String, dynamic> json) {
    if (json["day"] is int) this.day = json["day"];
    if (json["time"] is String) this.time = json["time"];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data["day"] = this.day;
    data["time"] = this.time;
    return data;
  }
}

class Close {
  int? day;
  String? time;

  Close({this.day, this.time});

  Close.fromJson(Map<String, dynamic> json) {
    if (json["day"] is int) this.day = json["day"];
    if (json["time"] is String) this.time = json["time"];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data["day"] = this.day;
    data["time"] = this.time;
    return data;
  }
}

class DetailGeometry {
  DetailLocation? location;
  DetailViewport? viewport;

  DetailGeometry({this.location, this.viewport});

  DetailGeometry.fromJson(Map<String, dynamic> json) {
    if (json["location"] is Map)
      this.location = json["location"] == null ? null : DetailLocation.fromJson(json["location"]);
    if (json["viewport"] is Map)
      this.viewport = json["viewport"] == null ? null : DetailViewport.fromJson(json["viewport"]);
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    if (this.location != null) data["location"] = this.location?.toJson();
    if (this.viewport != null) data["viewport"] = this.viewport?.toJson();
    return data;
  }
}

class DetailViewport {
  DetailNortheast? northeast;
  DetailSouthwest? southwest;

  DetailViewport({this.northeast, this.southwest});

  DetailViewport.fromJson(Map<String, dynamic> json) {
    if (json["northeast"] is Map)
      this.northeast =
          json["northeast"] == null ? null : DetailNortheast.fromJson(json["northeast"]);
    if (json["southwest"] is Map)
      this.southwest =
          json["southwest"] == null ? null : DetailSouthwest.fromJson(json["southwest"]);
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    if (this.northeast != null) data["northeast"] = this.northeast?.toJson();
    if (this.southwest != null) data["southwest"] = this.southwest?.toJson();
    return data;
  }
}

class DetailSouthwest {
  double? lat;
  double? lng;

  DetailSouthwest({this.lat, this.lng});

  DetailSouthwest.fromJson(Map<String, dynamic> json) {
    if (json["lat"] is double) this.lat = json["lat"];
    if (json["lng"] is double) this.lng = json["lng"];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data["lat"] = this.lat;
    data["lng"] = this.lng;
    return data;
  }
}

class DetailNortheast {
  double? lat;
  double? lng;

  DetailNortheast({this.lat, this.lng});

  DetailNortheast.fromJson(Map<String, dynamic> json) {
    if (json["lat"] is double) this.lat = json["lat"];
    if (json["lng"] is double) this.lng = json["lng"];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data["lat"] = this.lat;
    data["lng"] = this.lng;
    return data;
  }
}

class DetailLocation {
  double? lat;
  double? lng;

  DetailLocation({this.lat, this.lng});

  DetailLocation.fromJson(Map<String, dynamic> json) {
    if (json["lat"] is double) this.lat = json["lat"];
    if (json["lng"] is double) this.lng = json["lng"];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data["lat"] = this.lat;
    data["lng"] = this.lng;
    return data;
  }
}

class AddressComponents {
  String? longName;
  String? shortName;
  List<String>? types;

  AddressComponents({this.longName, this.shortName, this.types});

  AddressComponents.fromJson(Map<String, dynamic> json) {
    if (json["long_name"] is String) this.longName = json["long_name"];
    if (json["short_name"] is String) this.shortName = json["short_name"];
    if (json["types"] is List)
      this.types = json["types"] == null ? null : List<String>.from(json["types"]);
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data["long_name"] = this.longName;
    data["short_name"] = this.shortName;
    if (this.types != null) data["types"] = this.types;
    return data;
  }
}
