class HomeAgency {
  dynamic id;
  dynamic uuid;
  dynamic slug;
  dynamic description;
  dynamic facebook;
  dynamic twitter;
  dynamic instagram;
  dynamic formattedAddress;
  dynamic createdAt;
  dynamic updatedAt;
  dynamic status;
  dynamic ratings;
  HomeAgencyLogo? logo;
  HomeAgencySubscriptionOwner? subscriptionOwner;
  HomeAgencyCity? city;

  HomeAgency(
      {this.id,
      this.uuid,
      this.slug,
      this.description,
      this.facebook,
      this.twitter,
      this.instagram,
      this.formattedAddress,
      this.createdAt,
      this.updatedAt,
      this.status,
      this.ratings,
      this.logo,
      this.subscriptionOwner,
      this.city});

  HomeAgency.fromJson(Map<String, dynamic> json) {
    id = json["id"];
    uuid = json["uuid"];
    slug = json["slug"];
    description = json["description"];
    facebook = json["facebook"];
    twitter = json["twitter"];
    instagram = json["instagram"];
    formattedAddress = json["formattedAddress"];
    createdAt = json["createdAt"];
    updatedAt = json["updatedAt"];
    status = json["status"];
    ratings = json["ratings"];
    logo = json["logo"] == null ? null : HomeAgencyLogo.fromJson(json["logo"]);
    subscriptionOwner = json["subscriptionOwner"] == null
        ? null
        : HomeAgencySubscriptionOwner.fromJson(json["subscriptionOwner"]);
    city = json["city"] == null ? null : HomeAgencyCity.fromJson(json["city"]);
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> _data = <String, dynamic>{};
    _data["id"] = id;
    _data["uuid"] = uuid;
    _data["slug"] = slug;
    _data["description"] = description;
    _data["facebook"] = facebook;
    _data["twitter"] = twitter;
    _data["instagram"] = instagram;
    _data["formattedAddress"] = formattedAddress;
    _data["createdAt"] = createdAt;
    _data["updatedAt"] = updatedAt;
    _data["status"] = status;
    _data["ratings"] = ratings;
    if (logo != null) {
      _data["logo"] = logo?.toJson();
    }
    if (subscriptionOwner != null) {
      _data["subscriptionOwner"] = subscriptionOwner?.toJson();
    }
    if (city != null) {
      _data["city"] = city?.toJson();
    }
    return _data;
  }

  HomeAgency copyWith({
    dynamic id,
    dynamic uuid,
    dynamic slug,
    dynamic description,
    dynamic facebook,
    dynamic twitter,
    dynamic instagram,
    dynamic formattedAddress,
    dynamic createdAt,
    dynamic updatedAt,
    dynamic status,
    dynamic ratings,
    HomeAgencyLogo? logo,
    HomeAgencySubscriptionOwner? subscriptionOwner,
    HomeAgencyCity? city,
  }) =>
      HomeAgency(
        id: id ?? this.id,
        uuid: uuid ?? this.uuid,
        slug: slug ?? this.slug,
        description: description ?? this.description,
        facebook: facebook ?? this.facebook,
        twitter: twitter ?? this.twitter,
        instagram: instagram ?? this.instagram,
        formattedAddress: formattedAddress ?? this.formattedAddress,
        createdAt: createdAt ?? this.createdAt,
        updatedAt: updatedAt ?? this.updatedAt,
        status: status ?? this.status,
        ratings: ratings ?? this.ratings,
        logo: logo ?? this.logo,
        subscriptionOwner: subscriptionOwner ?? this.subscriptionOwner,
        city: city ?? this.city,
      );
}

class HomeAgencyCity {
  int? id;
  dynamic label;
  dynamic zip;
  dynamic district;
  int? numberOfResults;

  HomeAgencyCity(
      {this.id, this.label, this.zip, this.district, this.numberOfResults});

  HomeAgencyCity.fromJson(Map<String, dynamic> json) {
    id = json["id"];
    label = json["label"];
    zip = json["zip"];
    district = json["district"];
    numberOfResults = json["numberOfResults"];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> _data = <String, dynamic>{};
    _data["id"] = id;
    _data["label"] = label;
    _data["zip"] = zip;
    _data["district"] = district;
    _data["numberOfResults"] = numberOfResults;
    return _data;
  }

  HomeAgencyCity copyWith({
    int? id,
    dynamic label,
    dynamic zip,
    dynamic district,
    int? numberOfResults,
  }) =>
      HomeAgencyCity(
        id: id ?? this.id,
        label: label ?? this.label,
        zip: zip ?? this.zip,
        district: district ?? this.district,
        numberOfResults: numberOfResults ?? this.numberOfResults,
      );
}

class HomeAgencySubscriptionOwner {
  int? id;
  String? displayName;
  String? thumbnail;
  String? firebaseId;
  String? uniqueId;

  HomeAgencySubscriptionOwner(
      {this.id,
      this.displayName,
      this.thumbnail,
      this.firebaseId,
      this.uniqueId});

  HomeAgencySubscriptionOwner.fromJson(Map<String, dynamic> json) {
    id = json["id"];
    displayName = json["displayName"];
    thumbnail = json["thumbnail"];
    firebaseId = json["firebaseId"];
    uniqueId = json["uniqueId"];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> _data = <String, dynamic>{};
    _data["id"] = id;
    _data["displayName"] = displayName;
    _data["thumbnail"] = thumbnail;
    _data["firebaseId"] = firebaseId;
    _data["uniqueId"] = uniqueId;
    return _data;
  }

  HomeAgencySubscriptionOwner copyWith({
    int? id,
    String? displayName,
    String? thumbnail,
    String? firebaseId,
    String? uniqueId,
  }) =>
      HomeAgencySubscriptionOwner(
        id: id ?? this.id,
        displayName: displayName ?? this.displayName,
        thumbnail: thumbnail ?? this.thumbnail,
        firebaseId: firebaseId ?? this.firebaseId,
        uniqueId: uniqueId ?? this.uniqueId,
      );
}

class HomeAgencyLogo {
  int? id;
  dynamic url;
  dynamic compressedUrl;
  dynamic label;
  dynamic whisePictureId;

  HomeAgencyLogo(
      {this.id, this.url, this.compressedUrl, this.label, this.whisePictureId});

  HomeAgencyLogo.fromJson(Map<String, dynamic> json) {
    id = json["id"];
    url = json["url"];
    compressedUrl = json["compressedUrl"];
    label = json["label"];
    whisePictureId = json["whisePictureId"];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> _data = <String, dynamic>{};
    _data["id"] = id;
    _data["url"] = url;
    _data["compressedUrl"] = compressedUrl;
    _data["label"] = label;
    _data["whisePictureId"] = whisePictureId;
    return _data;
  }

  HomeAgencyLogo copyWith({
    int? id,
    dynamic url,
    dynamic compressedUrl,
    dynamic label,
    dynamic whisePictureId,
  }) =>
      HomeAgencyLogo(
        id: id ?? this.id,
        url: url ?? this.url,
        compressedUrl: compressedUrl ?? this.compressedUrl,
        label: label ?? this.label,
        whisePictureId: whisePictureId ?? this.whisePictureId,
      );
}
