
class HomeCategory {
  int? id;
  String? label;
  String? thumbnailUrl;
  List<HomeSubcat>? subcats;

  HomeCategory({this.id, this.label, this.thumbnailUrl, this.subcats});

  HomeCategory.fromJson(Map<String, dynamic> json) {
    id = json["id"];
    label = json["label"];
    thumbnailUrl = json["thumbnailUrl"];
    subcats = json["subcats"] == null ? null : (json["subcats"] as List).map((e) => HomeSubcat.fromJson(e)).toList();
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> _data = <String, dynamic>{};
    _data["id"] = id;
    _data["label"] = label;
    _data["thumbnailUrl"] = thumbnailUrl;
    if(subcats != null) {
      _data["subcats"] = subcats?.map((e) => e.toJson()).toList();
    }
    return _data;
  }

  HomeCategory copyWith({
    int? id,
    String? label,
    String? thumbnailUrl,
    List<HomeSubcat>? subcats,
  }) => HomeCategory(
    id: id ?? this.id,
    label: label ?? this.label,
    thumbnailUrl: thumbnailUrl ?? this.thumbnailUrl,
    subcats: subcats ?? this.subcats,
  );
}

class HomeSubcat {
  int? id;
  String? label;

  HomeSubcat({this.id, this.label});

  HomeSubcat.fromJson(Map<String, dynamic> json) {
    id = json["id"];
    label = json["label"];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> _data = <String, dynamic>{};
    _data["id"] = id;
    _data["label"] = label;
    return _data;
  }

  HomeSubcat copyWith({
    int? id,
    String? label,
  }) => HomeSubcat(
    id: id ?? this.id,
    label: label ?? this.label,
  );
}