import 'homelido_property_info.dart';

class HomelidoProperty {
  int? id;
  String? title;
  String? image;
  String? address;
  double? price;
  double? salePrice;
  int? bed;
  int? area;
  String? areaUnit;
  int? bathroom;
  String? currency;
  String? availableFrom;
  int? propertyType;
  HomelidoPropertyInfo? homelidoPropertyInfo;

  String? countryCode;
  String? countryName;

  HomelidoProperty({
    this.id,
    this.title,
    this.image,
    this.address,
    this.price,
    this.salePrice,
    this.bed,
    this.area,
    this.areaUnit,
    this.bathroom,
    this.currency,
    this.availableFrom,
    this.propertyType,
    this.homelidoPropertyInfo,
    this.countryCode,
    this.countryName,
  });

  HomelidoProperty.fromJson(Map<String, dynamic> json) {
    if (json["id"] is int) this.id = json["id"];
    if (json["title"] is String) this.title = json["title"];
    if (json["image"] is String) this.image = json["image"];
    if (json["address"] is String) this.address = json["address"];
    if (json["price"] is double) this.price = json["price"];
    if (json["salePrice"] is double) this.salePrice = json["salePrice"];
    if (json["bed"] is int) this.bed = json["bed"];
    if (json["area"] is int) this.area = json["area"];
    if (json["areaUnit"] is String) this.areaUnit = json["areaUnit"];
    if (json["bathroom"] is int) this.bathroom = json["bathroom"];
    if (json["currency"] is String) this.currency = json["currency"];
    if (json["availableFrom"] is String)
      this.availableFrom = json["availableFrom"];
    if (json["propertyType"] is int) this.propertyType = json["propertyType"];
    if (json['homelidoPropertyInfo'] != null)
      homelidoPropertyInfo =
          HomelidoPropertyInfo.fromJson(json['homelidoPropertyInfo']);
    if (json["countryCode"] is String) this.countryCode = json["countryCode"];
    if (json["countryName"] is String) this.countryName = json["countryName"];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data["id"] = this.id;
    data["title"] = this.title;
    data["image"] = this.image;
    data["address"] = this.address;
    data["price"] = this.price;
    data["salePrice"] = this.salePrice;
    data["bed"] = this.bed;
    data["area"] = this.area;
    data["areaUnit"] = this.areaUnit;
    data["bathroom"] = this.bathroom;
    data["currency"] = this.currency;
    data["availableFrom"] = this.availableFrom;
    data["propertyType"] = this.propertyType;
    data["countryCode"] = this.countryCode;
    data["countryName"] = this.countryName;
    return data;
  }
}
