import 'package:equatable/equatable.dart';

class HomelidoPropertyInfo extends Equatable {
  int? id;
  String? title;
  String? image;
  String? address;
  double? price;
  double? salePrice;
  int? bed;
  int? bedrooms;
  int? area;
  String? areaUnit;
  int? bathroom;
  String? currency;
  String? availableFrom;
  int? propertyType;
  String? content;
  String? bannerImage;
  double? lat;
  double? lng;
  int? isFeatured;
  List<String>? gallery;
  String? video;
  int? square;
  int? garages;
  String? deposit;
  String? poolSize;
  String? status;
  int? defaultState;
  int? view;
  String? recentView;
  int? isSold;
  int? placeId;
  String? adLanguageCode;
  String? energyLabel;
  String? energyPictureUrl;
  int? energyId;
  String? qrCode;
  int? isFeaturedUntil;
  int? isPublishedUntil;
  Owner? owner;
  Category? category;
  String? logoAgency;
  String? countryCode;
  String? countryName;
  int? timeSlide;

  HomelidoPropertyInfo(
      {this.id,
      this.title,
      this.image,
      this.address,
      this.price,
      this.salePrice,
      this.bed,
      this.bedrooms,
      this.area,
      this.areaUnit,
      this.bathroom,
      this.currency,
      this.availableFrom,
      this.propertyType,
      this.content,
      this.bannerImage,
      this.lat,
      this.lng,
      this.isFeatured,
      this.gallery,
      this.video,
      this.square,
      this.garages,
      this.deposit,
      this.poolSize,
      this.status,
      this.defaultState,
      this.view,
      this.recentView,
      this.isSold,
      this.placeId,
      this.adLanguageCode,
      this.energyLabel,
      this.energyPictureUrl,
      this.energyId,
      this.qrCode,
      this.isFeaturedUntil,
      this.isPublishedUntil,
      this.owner,
      this.category,
      this.logoAgency,
      this.countryCode,
      this.countryName,
      this.timeSlide});

  HomelidoPropertyInfo.fromJson(Map<String, dynamic> json) {
    if (json["id"] is int) {
      id = json["id"];
    }
    if (json["title"] is String) {
      title = json["title"];
    }
    if (json["image"] is String) {
      image = json["image"];
    }
    if (json["address"] is String) {
      address = json["address"];
    }
    if (json["price"] is double) {
      price = json["price"];
    }
    if (json["salePrice"] is double) {
      salePrice = json["salePrice"];
    }
    if (json["bed"] is int) {
      bed = json["bed"];
    }
    if (json["bedrooms"] is int) {
      bedrooms = json["bedrooms"];
    }
    if (json["area"] is int) {
      area = json["area"];
    }
    if (json["areaUnit"] is String) {
      areaUnit = json["areaUnit"];
    }
    if (json["bathroom"] is int) {
      bathroom = json["bathroom"];
    }
    if (json["currency"] is String) {
      currency = json["currency"];
    }
    if (json["availableFrom"] is String) {
      availableFrom = json["availableFrom"];
    }
    if (json["propertyType"] is int) {
      propertyType = json["propertyType"];
    }
    if (json["content"] is String) {
      content = json["content"];
    }
    if (json["bannerImage"] is String) {
      bannerImage = json["bannerImage"];
    }
    if (json["lat"] is double) {
      lat = json["lat"];
    }
    if (json["lng"] is double) {
      lng = json["lng"];
    }
    if (json["isFeatured"] is int) {
      isFeatured = json["isFeatured"];
    }
    if (json["gallery"] is List) {
      gallery =
          json["gallery"] == null ? null : List<String>.from(json["gallery"]);
    }
    if (json["video"] is String) {
      video = json["video"];
    }
    if (json["square"] is int) {
      square = json["square"];
    }
    if (json["garages"] is int) {
      garages = json["garages"];
    }
    if (json["deposit"] is String) {
      deposit = json["deposit"];
    }
    if (json["poolSize"] is String) {
      poolSize = json["poolSize"];
    }
    if (json["status"] is String) {
      status = json["status"];
    }
    if (json["defaultState"] is int) {
      defaultState = json["defaultState"];
    }
    if (json["view"] is int) {
      view = json["view"];
    }
    if (json["recentView"] is String) {
      recentView = json["recentView"];
    }
    if (json["isSold"] is int) {
      isSold = json["isSold"];
    }
    if (json["placeId"] is int) {
      placeId = json["placeId"];
    }
    if (json["adLanguageCode"] is String) {
      adLanguageCode = json["adLanguageCode"];
    }
    if (json["energyLabel"] is String) {
      energyLabel = json["energyLabel"];
    }
    if (json["energyPictureUrl"] is String) {
      energyPictureUrl = json["energyPictureUrl"];
    }
    if (json["energyId"] is int) {
      energyId = json["energyId"];
    }
    if (json["qrCode"] is String) {
      qrCode = json["qrCode"];
    }
    if (json["isFeaturedUntil"] is int) {
      isFeaturedUntil = json["isFeaturedUntil"];
    }
    if (json["isPublishedUntil"] is int) {
      isPublishedUntil = json["isPublishedUntil"];
    }
    if (json["owner"] is Map) {
      owner = json["owner"] == null ? null : Owner.fromJson(json["owner"]);
    }
    if (json["category"] is Map) {
      category =
          json["category"] == null ? null : Category.fromJson(json["category"]);
    }
    if (json["logoAgency"] is String) {
      logoAgency = json["logoAgency"];
    }
    if (json["countryCode"] is String) {
      countryCode = json["countryCode"];
    }
    if (json["countryName"] is String) {
      countryName = json["countryName"];
    }
    if (json["timeSlide"] is int) {
      timeSlide = json["timeSlide"];
    }
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> _data = <String, dynamic>{};
    _data["id"] = id;
    _data["title"] = title;
    _data["image"] = image;
    _data["address"] = address;
    _data["price"] = price;
    _data["salePrice"] = salePrice;
    _data["bed"] = bed;
    _data["bedrooms"] = bedrooms;
    _data["area"] = area;
    _data["areaUnit"] = areaUnit;
    _data["bathroom"] = bathroom;
    _data["currency"] = currency;
    _data["availableFrom"] = availableFrom;
    _data["propertyType"] = propertyType;
    _data["content"] = content;
    _data["bannerImage"] = bannerImage;
    _data["lat"] = lat;
    _data["lng"] = lng;
    _data["isFeatured"] = isFeatured;
    if (gallery != null) {
      _data["gallery"] = gallery;
    }
    _data["video"] = video;
    _data["square"] = square;
    _data["garages"] = garages;
    _data["deposit"] = deposit;
    _data["poolSize"] = poolSize;
    _data["status"] = status;
    _data["defaultState"] = defaultState;
    _data["view"] = view;
    _data["recentView"] = recentView;
    _data["isSold"] = isSold;
    _data["placeId"] = placeId;
    _data["adLanguageCode"] = adLanguageCode;
    _data["energyLabel"] = energyLabel;
    _data["energyPictureUrl"] = energyPictureUrl;
    _data["energyId"] = energyId;
    _data["qrCode"] = qrCode;
    _data["isFeaturedUntil"] = isFeaturedUntil;
    _data["isPublishedUntil"] = isPublishedUntil;
    if (owner != null) {
      _data["owner"] = owner?.toJson();
    }
    if (category != null) {
      _data["category"] = category?.toJson();
    }
    _data["logoAgency"] = logoAgency;
    _data["countryCode"] = countryCode;
    _data["countryName"] = countryName;
    _data["timeSlide"] = timeSlide;
    return _data;
  }

  @override
  List<Object?> get props => [id];
}

class Category {
  int? id;
  String? name;
  String? content;
  String? icon;
  String? slug;
  String? status;

  Category(
      {this.id, this.name, this.content, this.icon, this.slug, this.status});

  Category.fromJson(Map<String, dynamic> json) {
    if (json["id"] is int) {
      id = json["id"];
    }
    if (json["name"] is String) {
      name = json["name"];
    }
    if (json["content"] is String) {
      content = json["content"];
    }
    if (json["icon"] is String) {
      icon = json["icon"];
    }
    if (json["slug"] is String) {
      slug = json["slug"];
    }
    if (json["status"] is String) {
      status = json["status"];
    }
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> _data = <String, dynamic>{};
    _data["id"] = id;
    _data["name"] = name;
    _data["content"] = content;
    _data["icon"] = icon;
    _data["slug"] = slug;
    _data["status"] = status;
    return _data;
  }
}

class Owner {
  String? uniqueId;
  String? firebaseId;

  Owner({this.uniqueId, this.firebaseId});

  Owner.fromJson(Map<String, dynamic> json) {
    if (json["uniqueId"] is String) {
      uniqueId = json["uniqueId"];
    }
    if (json["firebaseId"] is String) {
      firebaseId = json["firebaseId"];
    }
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> _data = <String, dynamic>{};
    _data["uniqueId"] = uniqueId;
    _data["firebaseId"] = firebaseId;
    return _data;
  }
}
