class PmbDevice {
  String? id;
  String? serial;
  String? label;
  dynamic? publicName;
  dynamic? purchasedAt;
  dynamic? warrantyUntil;
  String? qrCodeDevice;
  double? lat;
  double? lng;
  int? closeOpenSchedule;
  int? readyToPour;
  int? amountRent;
  int? amountBuy;
  String? currency;
  int? width;
  int? height;
  int? depth;
  int? numberOfPumps;
  int? debitPerSec;
  int? distance;
  List<Beers>? beers;

  PmbDevice(
      {this.id,
      this.serial,
      this.label,
      this.publicName,
      this.purchasedAt,
      this.warrantyUntil,
      this.qrCodeDevice,
      this.lat,
      this.lng,
      this.closeOpenSchedule,
      this.readyToPour,
      this.amountRent,
      this.amountBuy,
      this.currency,
      this.width,
      this.height,
      this.depth,
      this.numberOfPumps,
      this.debitPerSec,
      this.distance,
      this.beers});

  PmbDevice.fromJson(Map<String, dynamic> json) {
    if (json["id"] is String) this.id = json["id"];
    if (json["serial"] is String) this.serial = json["serial"];
    if (json["label"] is String) this.label = json["label"];
    this.publicName = json["publicName"];
    this.purchasedAt = json["purchasedAt"];
    this.warrantyUntil = json["warrantyUntil"];
    if (json["qrCodeDevice"] is String)
      this.qrCodeDevice = json["qrCodeDevice"];
    if (json["lat"] is double) this.lat = json["lat"];
    if (json["lng"] is double) this.lng = json["lng"];
    if (json["closeOpenSchedule"] is int)
      this.closeOpenSchedule = json["closeOpenSchedule"];
    if (json["readyToPour"] is int) this.readyToPour = json["readyToPour"];
    if (json["amountRent"] is int) this.amountRent = json["amountRent"];
    if (json["amountBuy"] is int) this.amountBuy = json["amountBuy"];
    if (json["currency"] is String) this.currency = json["currency"];
    if (json["width"] is int) this.width = json["width"];
    if (json["height"] is int) this.height = json["height"];
    if (json["depth"] is int) this.depth = json["depth"];
    if (json["numberOfPumps"] is int)
      this.numberOfPumps = json["numberOfPumps"];
    if (json["debitPerSec"] is int) this.debitPerSec = json["debitPerSec"];
    if (json["distance"] is int) this.distance = json["distance"];
    if (json["beers"] is List)
      this.beers = json["beers"] == null
          ? null
          : (json["beers"] as List).map((e) => Beers.fromJson(e)).toList();
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data["id"] = this.id;
    data["serial"] = this.serial;
    data["label"] = this.label;
    data["publicName"] = this.publicName;
    data["purchasedAt"] = this.purchasedAt;
    data["warrantyUntil"] = this.warrantyUntil;
    data["qrCodeDevice"] = this.qrCodeDevice;
    data["lat"] = this.lat;
    data["lng"] = this.lng;
    data["closeOpenSchedule"] = this.closeOpenSchedule;
    data["readyToPour"] = this.readyToPour;
    data["amountRent"] = this.amountRent;
    data["amountBuy"] = this.amountBuy;
    data["currency"] = this.currency;
    data["width"] = this.width;
    data["height"] = this.height;
    data["depth"] = this.depth;
    data["numberOfPumps"] = this.numberOfPumps;
    data["debitPerSec"] = this.debitPerSec;
    data["distance"] = this.distance;
    if (this.beers != null)
      data["beers"] = this.beers?.map((e) => e.toJson()).toList();
    return data;
  }
}

class Beers {
  String? logoUrl;
  String? id;
  double? alcoholPourcentage;
  dynamic? biterOnTen;
  String? description;
  String? name;
  int? colorId;
  dynamic? videoUrl;
  String? colorName;
  double? salePriceByLiter;
  String? currency;
  double? arckipelToken;

  Beers({
    this.logoUrl,
    this.id,
    this.alcoholPourcentage,
    this.biterOnTen,
    this.description,
    this.name,
    this.colorId,
    this.videoUrl,
    this.colorName,
    this.salePriceByLiter,
    this.currency,
    this.arckipelToken,
  });

  Beers.fromJson(Map<String, dynamic> json) {
    if (json["logoUrl"] is String) this.logoUrl = json["logoUrl"];
    if (json["id"] is String) this.id = json["id"];
    if (json["alcoholPourcentage"] is double)
      this.alcoholPourcentage = json["alcoholPourcentage"];
    this.biterOnTen = json["biterOnTen"];
    if (json["description"] is String) this.description = json["description"];
    if (json["name"] is String) this.name = json["name"];
    if (json["colorId"] is int) this.colorId = json["colorId"];
    this.videoUrl = json["videoUrl"];
    if (json["colorName"] is String) this.colorName = json["colorName"];
    if (json["salePriceByLiter"] is double)
      this.salePriceByLiter = json["salePriceByLiter"];
    if (json["currency"] is String) this.currency = json["currency"];
    if (json["arckipelToken"] is double)
      this.arckipelToken = json["arckipelToken"];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data["logoUrl"] = this.logoUrl;
    data["id"] = this.id;
    data["alcoholPourcentage"] = this.alcoholPourcentage;
    data["biterOnTen"] = this.biterOnTen;
    data["description"] = this.description;
    data["name"] = this.name;
    data["colorId"] = this.colorId;
    data["videoUrl"] = this.videoUrl;
    data["colorName"] = this.colorName;
    data["salePriceByLiter"] = this.salePriceByLiter;
    data["currency"] = this.currency;
    data["arckipelToken"] = this.arckipelToken;
    return data;
  }
}
