import '../resources.dart';

class EmergencyRepository {
  EmergencyRepository._();

  static EmergencyRepository? _instance;

  factory EmergencyRepository([AppApi? api]) {
    if (_instance == null) _instance = EmergencyRepository._();
    _instance!._api = api ?? AppApiImp();
    return _instance!;
  }

  late AppApi _api;

  Future<EmergencyResult?> getEmergencyInfos(emergencyId, countryCode) async {
    NetworkResponse response = await _api.getEmergencyInfos(
        {'emergencyId': emergencyId, 'countryCode': countryCode});
    return response.data;
  }

  Future<bool> sendEmergencyRequest(params) async {
    NetworkResponse response = await _api.sendEmergencyRequest(params);
    return response.data ?? false;
  }
}
