import '../resources.dart';

class LocationRepo {
  LocationRepo._();

  static LocationRepo? _instance;

  factory LocationRepo([AppApi? api]) {
    _instance ??= LocationRepo._();
    _instance!._api = api ?? AppApiImp();
    return _instance!;
  }

  late AppApi _api; 

  Future<LocationModel?> addLocationForUser(params) async {
    NetworkResponse response = await _api.addLocationForUser(params);
    return response.data;
  }

  Future<List<LocationModel>> getLocationFromUser(params) async {
    NetworkResponse response = await _api.getLocationFromUser(params);
    return response.data ?? [];
  }

  Future<bool> removeLocationForUser(params) async {
    NetworkResponse response = await _api.removeLocationForUser(params);
    return response.data ?? false;
  }

  Future<bool> setLocationDefault(params) async {
    NetworkResponse response = await _api.setLocationDefault(params);
    return response.data ?? false;
  }

  Future<bool> updateLocationForUser(params) async {
    NetworkResponse response = await _api.updateLocationForUser(params);
    return response.data ?? false;
  }
}
